function [Y, F] = specgram(y, nFFT, fs, win, nOverlap)
    
    N = length(y);
    reso = nFFT - nOverlap;
    m = fix((N - nOverlap) / reso);
    j = 1 + (0 : (m - 1)) * reso;
    i = (1 : nFFT)';
    
    y = y(i(:,ones(1, m)) + j(ones(nFFT, 1), :) - 1);
    y = y .* repmat(win, 1, m);
    Y = fft(y, nFFT);
    Y = Y(1 : nFFT / 2 + 1, :);
    F = (0:nFFT / 2)' * fs / nFFT;