function x = voice(y, fs, n, f_up)
    
    y = mean(y, 2);
    [Y, F] = specgram(y, 1024, fs, hamming(1024), 1024 - 0.01 * fs);
    powerSpec = mean(abs(Y).^2, 2);
    powerSpec = powerSpec / sum(powerSpec);
    powerSpec = powerSpec(F < f_up);
    F = F(F < f_up);
    for i = 1 : n
        len = length(powerSpec);
        x(i) = max(powerSpec((i-1) * len / n + 1 : i * len / n));
    end
    x = log10(x);
    
function [Y, F] = specgram(y, nFFT, fs, win, nOverlap)
    
    N = length(y);
    reso = nFFT - nOverlap;
    m = fix((N - nOverlap) / reso);
    j = 1 + (0 : (m - 1)) * reso;
    i = (1 : nFFT)';
    y = y(i(:, ones(1, m)) + j(ones(nFFT, 1), :) - 1);
    y = y .* repmat(win, 1, m);
    Y = fft(y, nFFT);
    Y = Y(1 : nFFT / 2 + 1, :);
    F = (0 : nFFT / 2)' * fs / nFFT;
    
function w = hamming(N)
    
    w = (54 - 46 * cos(2 * pi * (0 : (N-1))' / (N-1))) / 100;
    
