class ExitButton extends Button{
  ExitButton(int x0, int y0, boolean isPressed0, int buttonHeight0, int buttonWidth0){
    super(x0, y0, isPressed0, buttonHeight0, buttonWidth0);
  }
  void action(int num0){
    println("exit");
    println("See you again ...");
    exit();
  }
  void display(){
    fill(50);
    rect(x, y, buttonWidth, buttonHeight);
    fill(160);
    rect(x, y, 2, buttonHeight);
    fill(100);
    rect(x+buttonWidth-2, y, 2, buttonHeight);
    fill(180);
    rect(x+1, y, buttonWidth-2, 2);
    if(isPressed == false){
      fill(128);
    }
    else{
      fill(28);
    }
    rect(x+2, y+2, buttonWidth-4, buttonHeight-4);
    //上,下,右//矢印
    fill(0);
    textSize(25);
    text("E",x+8, y+23);
    textSize(10);
  }
}

//-------------------------------------------------------------------------------
class GroundworkAggregation{
  GroundworkButton[] bGw;
  String[] lines;
  String[] bGwNames;
  int[] bGwNums;
  GroundworkAggregation(){
    String[] q;
    lines = loadStrings("climaxTXT/climax_Sequence.txt"); //テキストファイル読込
    bGwNames = new String[lines.length/7];
    bGwNums = new int[lines.length/7];
    bGw = new GroundworkButton[lines.length/7];
    for(int i = 0;i < lines.length/7;i++){
      q = splitTokens(lines[i*7],",");
      String[] r = splitTokens(q[1],"/");
      bGwNums[i] = i;
      bGwNames[i] = r[2];
      bGw[i] = new GroundworkButton(width-95,i*24,false,24,95);
    }
  }
  void display(){
    for(int i = 0;i < lines.length/7;i++){
      bGw[i].display();
      fill(0);
      text(bGwNames[i],width-90,i*24+(24/3*2));
    }
  }
  void aggregationGroundworkBottunHitted(){
    for(int i = 0;i < lines.length/7;i++){
      if(bGw[i].isHitted() == true){
        bGw[i].setIsPressed(true);
        c.setState(5);
      }
      else{
        bGw[i].setIsPressed(false);
      }
    }
  }
  void aggregationGroundworkBottunPressed(){
    for(int i = 0;i < lines.length/7;i++){
      if(bGw[i].isPressed() == true){
        d.setTextLogExperiment("Seaquence ボタンが押されました。", i+"番目:"+bGwNames[i]);
        bGw[i].action(i);
        //c.passPreparationMatrix();//悩み中
        bGw[i].setIsPressed(false);
      }
    }
  }
  void aggregationGroundworkBottunPressedFalse(){
    for(int i = 0;i < lines.length/7;i++){
      bGw[i].setIsPressed(false);
    }
  }
}
class GroundworkButton extends Button{
  GroundworkButton(int x0, int y0, boolean isPressed0, int buttonHeight0, int buttonWidth0){
    super(x0, y0, isPressed0, buttonHeight0, buttonWidth0);
  }
  void action(int num0){
    //d.setTextLog("GroundworkButton action(int num0) "+num0);
    c.setSelectSequence(num0*7);
    println(s.soundData2.get(Part.SEQ).get(num0*7).name +"PLAY NOW!");
    if(g.flagPlayingMusic == true){
      sp.wavStop();
    }
    sp.wavplay(num0*7,Part.SEQ);
    if(g.flagGroundworkPlayingMusic == false){
      c.swicthFlagGroundworkPlayingMusic();
    }
  }
  void display(){
    //d.setTextLog("GroundworkButton display() ");
    fill(130);
    rect(x, y, buttonWidth, buttonHeight);
    fill(240);
    rect(x, y, 2, buttonHeight);
    fill(180);
    rect(x+buttonWidth-2, y, 2, buttonHeight);
    fill(255);
    rect(x+1, y, buttonWidth-2, 2);
    if(isPressed == false){      fill(208);}
    else{                        fill(108);}
    rect(x+2, y+2, buttonWidth-4, buttonHeight-4);
  }
}
//----------------------------------------------------------------------------
class StartButton extends Button{
  StartButton(int x0, int y0, boolean isPressed0, int buttonHeight0, int buttonWidth0){
    super(x0, y0, isPressed0, buttonHeight0, buttonWidth0);
  }
  void action(int num0){
    sp.output();
    c.setFlagPlayingMusic(true);
  }
  void display(){
    fill(50);
    rect(x, y, buttonWidth, buttonHeight);
    fill(160);
    rect(x, y, 2, buttonHeight);
    fill(100);
    rect(x+buttonWidth-2, y, 2, buttonHeight);
    fill(180);
    rect(x+1, y, buttonWidth-2, 2);
    if(isPressed == false){
      fill(128);
    }
    else{
      fill(28);
    }
    rect(x+2, y+2, buttonWidth-4, buttonHeight-4);
    //上,下,右//矢印
    fill(255,0,0);
    triangle(x+(buttonWidth/3),y+(buttonHeight/5), x+(buttonWidth/3),y+(buttonHeight/5*4), x+(buttonWidth/5*4),y+(buttonHeight/2));
    fill(85,0,0);
    triangle(x+(buttonWidth/3),y+(buttonHeight/6*5), x+(buttonWidth/3),y+(buttonHeight/5*4), x+(buttonWidth/5*4),y+(buttonHeight/2));
  }
}
class StopButton extends Button{
  StopButton(int x0, int y0, boolean isPressed0, int buttonHeight0, int buttonWidth0){
    super(x0, y0, isPressed0, buttonHeight0, buttonWidth0);
  }
  void action(int num0){
    if(g.flagPlayingMusic == true){
      sp.wavStop();
    }
  }
  void display(){
    fill(50);
    rect(x, y, buttonWidth, buttonHeight);
    fill(160);
    rect(x, y, 2, buttonHeight);
    fill(100);
    rect(x+buttonWidth-2, y, 2, buttonHeight);
    fill(180);
    rect(x+1, y, buttonWidth-2, 2);
    if(isPressed == false){
      fill(128);
    }
    else{
      fill(28);
    }
    rect(x+2, y+2, buttonWidth-4, buttonHeight-4);
    ////四角
    fill(0,255,0);
    rect(x+(buttonWidth/8*2), y+(buttonHeight/8*2), (buttonWidth/8*6), (buttonHeight/8*6));  
    fill(0,85,0);
    rect(x+(buttonWidth/8*2), y+(buttonHeight/8*7)+((buttonHeight/8*1)), (buttonWidth/8*6), (buttonHeight/8*1)/2);  
  }
}
abstract class Button{
  int x;
  int y;
  boolean isPressed;
  int buttonHeight;
  int buttonWidth;
  Button(int x0, int y0, boolean isPressed0, int buttonHeight0, int buttonWidth0){
    x=x0;
    y=y0;
    isPressed = isPressed0;
    buttonHeight = buttonHeight0;
    buttonWidth = buttonWidth0; 
  }
  abstract void display();
  abstract void action(int num0);
  boolean isHitted(){
    if(x <= mouseX && mouseX < x+buttonWidth &&
        y <= mouseY && mouseY < y+buttonHeight){
      //println("Pressed");
      return true;
    }
    return false;
  }
  boolean isPressed(){
    return isPressed;
  }
  void setIsPressed(boolean b0){
    isPressed = b0;
  }
}

