class LineMaker{
  int y[];
  int climaxZone[];  //一拍子ごとのclimax
  int climaxAveZone[];//一小節ごとのclimax
  int climaxY[];
  color lineColor[];
  int lineWidth;
  int lineHeight;
  LineMaker(int lw0, int lh0){
    lineWidth = lw0;
    lineHeight = lh0;
    y = new int[lw0];
    lineColor = new int[lw0];
    climaxY = new int[lw0];
    climaxZone = new int[lw0/g.blockWidth];
    climaxAveZone = new int[climaxZone.length/4];
    resetY();
  }
  void resetY(){
    for(int i = 0;i < y.length;i++){
      y[i] = -1;
      lineColor[i] = color(0,0,0);
      climaxY[i] = 1;
    }
  }
  
  void setHighLowY(int x0, int y0, int x1, int y1){
    if(x0 < x1){
      flatY(x0, y0, x1, y1);
    }
    else if(x1 < x0){
      flatY(x1, y1, x0, y0);
    }
    else{
      flatY(x0, y0, x1, y1);
    }
    
  }
  void flatY(int x0, int y0, int x1, int y1){
    if(x1 != x0){
      for(int i = x0+1;i < x1;i++){
        setLineColor(i,int((float(y1-y0)/float(x1-x0))*float(i-x0))+y0);
        setY(i,int((float(y1-y0)/float(x1-x0))*float(i-x0))+y0);
        setClimaxY(i,int((float(y1-y0)/float(x1-x0))*float(i-x0))+y0);
      }
    }
    setY(x0,y0);
    setLineColor(x0,y0);
    setClimaxY(x0,y0);
    setY(x1,y1);
    setLineColor(x1,y1);
    setClimaxY(x1,y1);
    popularityContest();
  }
  
  void popularityContest(){
    for(int i = 0;i < climaxZone.length;i++){
      int climax[] = new int[5];
      int max1 = 0;
      for(int j = (i)*g.blockWidth;j < (i+1)*g.blockWidth;j++){
        if(g.WINDOW_WIDTH <= j){
          break;
        }
        //point(j,(climaxY[j]-1)*40+200);
        climax[climaxY[j]-1]++;
      }
      //text(max1+1,i*30,400);
      climaxZone[i] = ranking(climax)+1;
    }
    //1小節ごとの平均
    for(int i = 0;i < g.blockLengthX; i+=4){  //4小節分　平均の盛り上がり度計算
      climaxAveZone[(i/4)]=(climaxZone[i]+climaxZone[i+1]+climaxZone[i+2]+climaxZone[i+3])/4;
      print("ave:"+((i/4)+1)+":"+climaxAveZone[(i/4)]+" ");
    }
    println();
    //
  }
  int ranking(int num[]){
    int m = max(num);
    for(int i = 0;i < 5;i++){
      if(num[i] == m){
        return i;
      }
    }
    return 0;
  }
//  int re4_maxLevel(int nx){
  int getClimaxMax_4(int nx){
    //println("MouseDrawing re4_maxLevel(int nx) "+" nx:"+nx);
    int max0;
    max0 = climaxZone[nx];
    for(int i = 1; i < 4; i++){
      if(max0 < climaxZone[nx+i]){
        max0 = climaxZone[nx+i];
      }      
    }
    return max0;
  }
  //lineColor[]
  color getLineColor(int x0){
    return lineColor[x0];
  }
  void setLineColor(int x0, int y0){
    if(0 <= x0 && x0 < lineWidth &&
       0 <= y0 && y0 < lineHeight){
      if(5 <= (lineHeight-y0)/(lineHeight/5)+1){
        lineColor[x0] = color(255,0,0);
      }
      else if(4 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 5){
        lineColor[x0] = color(128,128,0);
      }
      else if(3 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 4){
        lineColor[x0] = color(0,255,0);
      }
      else if(2 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 3){
        lineColor[x0] = color(0,128,128);
      }
      else if(1 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 2){
        lineColor[x0] = color(0,0,255);
      }
    }
  }
  //climaxY[]
  int getClimaxY(int x0){
    return climaxY[x0];
  }
  void setClimaxY(int x0, int y0){
    if(0 <= x0 && x0 < lineWidth &&
       0 <= y0 && y0 < lineHeight){
      if(5 <= (lineHeight-y0)/(lineHeight/5)+1){
        climaxY[x0] = 5;
//        println(5);
      }
      else if(4 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 5){
        climaxY[x0] = 4;
//        println(4);
      }
      else if(3 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 4){
        climaxY[x0] = 3;
//        println(3);
      }
      else if(2 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 3){
        climaxY[x0] = 2;
//        println(2);
      }
      else if(1 <= (lineHeight-y0)/(lineHeight/5)+1 &&
              (lineHeight-y0)/(lineHeight/5)+1 < 2){
        climaxY[x0] = 1;
//        println(1);
      }
    }
  }
  //climaxZone[]
  int getClimaxZone(int x0){
    return climaxZone[x0];
  }
  //climaxAveZone[]
  int getClimaxAveZone(int x0){
    return climaxAveZone[x0];
  }
  //y[]
  int getY(int x0){
    return y[x0];
  }
  void setY(int x0, int y0){
    if(0 <= x0 && x0 < lineWidth &&
       0 <= y0 && y0 < lineHeight){
      y[x0] = y0;
    }
  }
  //y.length
  int getLengthY(){
    return y.length;
  }
  //climaxZone.length
  int getLengthClimaxZone(){
    return climaxZone.length;
  }
  //climaxAveZone.length
  int getLengthClimaxAveZone(){
    return climaxAveZone.length;
  }
  //lineWidth
  int getLW(){
    return lineWidth;
  }
  //lineHeight
  int getLH(){
    return lineHeight;
  }
}
