class SoundPlayer{
  CMXController cmx = CMXController.getInstance();
  int sec_loop = 1;
  
  int soundLength;//曲の長さ
  int soundSeconds = 0;//曲が鳴ってからの位置
  int soundBlockPoint = 0; //鳴ってる場所
  String soundLengthString = "";//表示用
  String soundSecondsString = "0:00";//表示用
  
  SoundPlayer(){
  }
  void initSoundLength(){
    soundLength = int(clucSecond()*sec_loop);
    soundLengthString = timeFinishGrading(soundLength);
  }
  void wavStop(){//指定されたwavファイル再生、ループはしません
    d.setTextLog("SoundPlayer wavStop(");
    cmx.stopMusic();
    c.setFlagPlayingMusic(false);
    println("stop");
  }
  float clucSecond(){//曲の秒数計算 今は時間固定なので簡易計算
    d.setTextLog("SoundPlayer clucSecond())");
    //大幅消去
    return 3.422*g.blockLengthX;
  }
  void wavplay(int x0, Part part0){//指定されたwavファイル再生、ループはしません
    d.setTextLog("SoundPlayer wavplay(int x0, Part part0)");
    if(x0 >=0 ){
      WAVWrapper[] wavfile;//wavファイル
      wavfile = new WAVWrapper[1];
      try {
        wavfile[0] = WAVWrapper.read(createInput(s.soundData2.get(part0).get(x0).path));
      } catch (IOException e) {
        println("File cannot be read.");
      }
      cmx.wavread(wavfile[0]);
      cmx.setMusicLoop(false);
      cmx.playMusic();
    }else{
      println("Not selected file");
    }
  }

  void output(){//WAV合成、出力 sec_loopは１セクタ繰り返し回数最初に宣言済み
    d.setTextLog("SoundPlayer output()");
    //println("method Output()");
    if(g.flagPlayingMusic == true){
      wavStop();
    }
    WAVWrapper[][] wavfiles;//wavファイル
    wavfiles = new WAVWrapper[g.blockLengthX][g.blockLengthY];
    smx.fixMatrix();
    //出力
    String s1 = year()+"年"+month()+"月"+day()+"日"+hour()+"時"+minute()+"分"+second()+"秒.txt";
    d.textWriterLine(str(l.y), s1);
    d.textWriterBlocks(smx.matrixId, true, s1);
    d.textWriterLines();//実験ログ用
    d.textWriterBlocks(smx.matrixId, false, null);
    //
    println("Wav Now Loading"); //int [][] matrixId = new int[g.blockLengthX][g.blockLengthY];
    print("[");
    for(int i = 0;i < g.blockLengthX;i++){
      print(" ");
    }
    println("]");
    print("[");
    for(int i = 0;i < g.blockLengthX;i++){
      //print(i+"     ");
      for (Part part : Part.values()) {
        int n1 = c.getMatrixId(i, part);
        if(n1 != -1){
          //println(c.getSearchMaterialPath(c.getMatrixId(i, j), j));
          if(g.flagReadWavTiming == false){
            wavfiles[i][part.ordinal()] = setWavFiles2(i, part);
          }
        }
      }
      
      /*
      for(int j = 0;j < g.blockLengthY;j++){
        if(c.getMatrixId(i, j) != -1){
          //println(c.getSearchMaterialPath(c.getMatrixId(i, j), j));
          wavfiles[i][j] = setWavFiles(i, j);
        }
      }
      */
      print("W");
    }
    println("]");
    println("Start output.");
    MutableWaveform newwave = new MutableWaveform(clucSecond()*sec_loop, 44100, 1);
    //Outputblock();
    for(int i = 0;i < g.blockLengthX;i++){
      for (Part part : Part.values()) {
        int n2 = c.getMatrixId(i, part);
        //println("n2_"+n2);
        if(n2 != -1){
          for(int k = 0; k < sec_loop; k++){
            if(g.flagReadWavTiming == false){
              if(wavfiles[i][part.ordinal()] != null){
                newwave.mix(wavfiles[i][part.ordinal()], sec_loop*i*150800 + k*150760, 0.2);//4秒[211680
              }
            }
            else{
              newwave.mix(s.soundData2.get(part).get(n2).getWavFile(), sec_loop*i*150800 + k*150760, 0.2);//4秒[211680
            }
          }
          print("Check:"+i+","+part.ordinal());
        }
      }
    }
    try {
      WAVWrapper w = new WAVWrapper(newwave);
      String name = "block/sound"+g.PIECES_LENGTH+".wav";
      w.write(createOutput(name));
      if(g.flagAutoSave == true){
        name = "sample/"+year()+"-"+month()+"-"+day()+"_"+hour()+"-"+minute()+"-"+second()+"_"+g.PIECES_LENGTH+".wav";
        //name = "sample/"+year()+month()+day()+"_"+hour()+minute()+second()+"_"+g.PIECES_LENGTH+".wav";
        w.write(createOutput(name));
        println("save->"+name);
      }
      //ここで素材の配置データも記録
      name = "block/sound"+g.PIECES_LENGTH+".wav";
      cmx.wavread(0,createInput(name));
      cmx.setMusicLoop(true);
      cmx.playMusic(0);
     } catch (IOException e) {
       println("I/O Error");
     }
     g.flagPlayingMusic = true;
     println("Done.");
  }
  String timeFinishGrading(int num0){
    String s1 = "";
    String s2 = "";
    int minute1 = 0;
    int second1 = 0;
    int num1 = num0;
    second1 = num1;
    while(true){
      num1 -= 60;
      if(num1 <= 0){
        num1 *= -1;
        break;
      }
      minute1++;
      second1 = num1;
    }
    if(second1 < 10){
      s2 = "0"+second1;
    }
    else{
      s2 = str(second1);
    }
    s1 = minute1+":"+s2;
    return s1;
  }
  void setSoundSeconds(){
    if(g.flagPlayingMusic == true){
      soundSeconds = int(cmx.getMicrosecondPosition())/1000000;
      soundSeconds = soundSeconds%soundLength;
      soundBlockPoint = int((float)(soundSeconds)/3.422);
      //println(soundSeconds+"^"+soundBlockPoint);
      soundSecondsString = timeFinishGrading(soundSeconds);
    }
  }
  int getSoundLength(){
    return soundLength;
  }
  int getSoundSeconds(){
    return soundSeconds;
  }
  int getSoundBlockPoint(){
    return soundBlockPoint;
  }
  String getSoundLengthString(){
    return soundLengthString;
  }
  String getSoundSecondsString(){
    return soundSecondsString;
  }
  WAVWrapper setWavFiles1(int x0, Part part0){
    d.setTextLog("WAVWrapper setWavFiles1(int x0, int y0)");
    WAVWrapper data;
    String path;
    path = c.getSearchMaterialPath(x0, part0);
    //println(path);
    try {
      data = WAVWrapper.read(createInput(path));
      return data;
    } catch (IOException e) {
      println("File cannot be read.");
    }
    return null;
  }
  WAVWrapper setWavFiles2(int x0, Part part0){
    d.setTextLog("WAVWrapper setWavFiles2(int x0, int y0)");
    WAVWrapper data;
    String path;
    path = c.getSearchMaterialPath(c.getMatrixId(x0, part0), part0);
    //println(path);
    try {
      data = WAVWrapper.read(createInput(path));
      return data;
    } catch (IOException e) {
      println("File cannot be read.");
    }
    return null;
  }
}
